-- Handles bob-omb buddy quiz

local DIALOG_QUIZ_START = (
    "Hi! I'll prepare the\n"
    .. "cannon for you!\n"
    .. "...If you answer\n"
    .. "this question correctly!")

local DIALOG_QUIZ_CORRECT = (
    "Correct! Right! True!\n"
    .. "Here's your prize!")

local DIALOG_QUIZ_WRONG = (
    "Wrong! Left! False!\n"
    .. "You've lost!\n\n"
    .. "As punishment, you\n"
    .. "will be punched in\n"
    .. "the face!")

local questionList = {
    { "How many coins can be\nfound in The Princess's\nSecret Slide?\n\n\n//64 coins\n//80 coins\n//90 coins\n//73 coins", 2 },
    { "Which of these actions\ncan you perform a kick\nduring?\n\n\n//Triple Jump\n//Freefall\n//Wall Kick\n//Walking", 4 },
    { "Which of these enemies\ncan be punched?\n\n\n\n//Spiny\n//Chain Chomp\n//Bowser\n//Mr. I", 1 },
    { "How many Dark Stars are\navailable in this mod?\n\n\n\n//2\n//0\n//3\n//5", 3 },
    { "How much damage does\ncontact with a\nKoopa Troopa deal?\n\n\n//0 HP\n//1 HP\n//2 HP\n//3 HP", 1 },
    { "How many unique 1-Up\nmushrooms are there in\nSuper Mario 64?\n\n\n//144\n//121\n//113\n//158", 2},
    { "Who FIRST tells you\nhow to defeat Bowser?\n\n\n\n//Toad\n//Lakitu\n//Peach\n//Bowser", 3},
    { "Which word does not\nappear in-game in\nSuper Mario 64?\n(In English)\n\n//Santa\n//Dragon\n//Linguine\n//Pirate", 4},
    { "Klepto has an unused\nstate in which he is\ndoing what?\n\n\n//Holding a blue star\n//Holding Mario\n//Crying\n//Dead", 1},
    { "What is the name of\nflower-like enemy found\nin Snowman's Land and\nCool, Cool Mountain?\n\n//Flower Head\n//Mary\n//Dayzee\n//Spindrift", 4},
    { "Which stage does NOT\nhave water?\n\n\n\n//Whomp's Fortress\n//Bob-Omb Battlefield\n//Tall, Tall Mountain\n//Cool, Cool Mountain", 2},
    { "Of these four enemies,\nwhich directly deals\nthe most damage?\n\n\n//Chain Chomp\n//Bowser Bomb\n//Heave-Ho\n//Amp", 1},
    { "Which of these Stars has\nthe longest single-star\nRTA world record?\n\n\n//DDD: 100 Coins\n//TTM: Monkey Cage\n//HMC: 100 Coins\n//BITS: Red Coins", 3},
    { "What does the \'90 Star\'\ncategory mean?\n(\'Main\' means main\n15 courses\')\n\n//Any 90 stars\n//All stars in main\n//First 6 stars in main\n//Does not exist", 3},
    { "How much time do you\nhave to perform a\nWall Kick after\nhitting a wall?\n\n//Third of a second\n//Sixth of a second\n//Half of a second\n//1 second", 2},
    { "How many lives do\nyou start with?\n\n\n\n//3 lives\n//4 lives\n//5 lives\n//6 lives", 1},
    { "How long can you\nhold Chuckya before\nhe escapes your grasp?\n\n\n//5 seconds\n//10 seconds\n//20 seconds\n//Forever", 4},
    { "What is Course 4\nin Super Mario 64?\n\n\n\n//Big Boo's Haunt\n//Cool, Cool Mountain\n//Jolly Roger Bay\n//Princess's Secret Slide", 2},
    { "In Super Mario 64 DS,\nhow many Stars can be\nobtained in Act 1 of\nBob-Omb-Battlefield?\n\n//5 Stars\n//6 Stars\n//7 Stars\n//8 Stars", 1},
    { "At how many stars does\nthe Toad on the top floor\nof the castle appear\nin Super Mario 64?\n\n//10 Stars\n//25 Stars\n//35 Stars\n//50 Stars", 3},
    { "Which of these stages\ndoes NOT have a cannon?\n\n\n\n//Cool, Cool Mountain\n//Jolly Roger Bay\n//Tiny Huge Island\n//Tower Of The Wing Cap", 4},
    { "How many red coin\nstars are there in\nSuper Mario 64?\n\n\n//22\n//23\n//24\n//25", 2},
    { "What am I called?\n\n\n\n\n//Pink Bob-Omb\n//Bob-Omb Pal\n//Friendly Bob-Omb\n//Bob-Omb Buddy", 4},
    { "Which ONE of these\nstatements is\nFALSE?\n\n\n//Below is false\n//Fourth is false\n//Above is false\n//Above is true", 2},
    { "What pronouns are used\nto refer to Dorrie\nin Super Mario 64?\n\n\n//He, Him\n//She, Her\n//They, Them\n//It, Its", 1},
}

local bobombQuizActive = false
local bobombQuizAnswer = 0
local bobombQuizQuestion = 0
local gotQuestionRight = false
local BOBOMB_BUDDY_CANNON_QUIZ_START = BOBOMB_BUDDY_CANNON_STOP_TALKING + 1
local BOBOMB_BUDDY_CANNON_QUIZ_ASK = BOBOMB_BUDDY_CANNON_STOP_TALKING + 2
local BOBOMB_BUDDY_CANNON_QUIZ_WRONG = BOBOMB_BUDDY_CANNON_STOP_TALKING + 3

function custom_buddy_init(o)
    gotQuestionRight = false
end

function custom_buddy_loop(o)
    bobombQuizActive = false
    if _G.bossRushOn and o.oAction ~= BOBOMB_BUDDY_ACT_TALK and o.oBobombBuddyRole == BOBOMB_BUDDY_ROLE_CANNON and o.oBobombBuddyCannonStatus ~= BOBOMB_BUDDY_CANNON_OPENED then
        o.oAction = BOBOMB_BUDDY_ACT_TALK
    end

    if o.oAction == BOBOMB_BUDDY_ACT_TALK and o.oBobombBuddyRole == BOBOMB_BUDDY_ROLE_CANNON then
        if o.oBobombBuddyCannonStatus == BOBOMB_BUDDY_CANNON_UNOPENED or o.oBobombBuddyCannonStatus == BOBOMB_BUDDY_CANNON_OPENED then
            if gotQuestionRight then return end
            local file = get_current_save_file_num() - 1
            local course = gNetworkPlayers[0].currCourseNum
            if save_file_is_cannon_unlocked(file, course) == 0 then
                if o.oBobombBuddyCannonStatus == BOBOMB_BUDDY_CANNON_UNOPENED then
                    smlua_text_utils_dialog_replace(gBehaviorValues.dialogs.BobombBuddyBob1Dialog, 1, 2, 95, 200,
                        DIALOG_QUIZ_START)
                    o.oBobombBuddyCannonStatus = BOBOMB_BUDDY_CANNON_QUIZ_START
                else
                    o.oBobombBuddyCannonStatus = BOBOMB_BUDDY_CANNON_UNOPENED
                end
            else
                o.oBobombBuddyCannonStatus = BOBOMB_BUDDY_CANNON_OPENED
            end
        elseif o.oBobombBuddyCannonStatus == BOBOMB_BUDDY_CANNON_QUIZ_START then
            local buddyText = 1
            if not _G.bossRushOn then
                buddyText = cutscene_object_with_dialog(CUTSCENE_DIALOG, o, gBehaviorValues.dialogs.BobombBuddyBob1Dialog)
            end

            if buddyText ~= 0 then
                if not _G.bossRushOn then
                    bobombQuizQuestion = math.random(1, #questionList)
                elseif bobombQuizQuestion == #questionList then
                    o.oBobombBuddyCannonStatus = BOBOMB_BUDDY_CANNON_OPENED
                    return
                else
                    bobombQuizQuestion = bobombQuizQuestion + 1
                end
                local question = questionList[bobombQuizQuestion]
                smlua_text_utils_dialog_replace(gBehaviorValues.dialogs.BobombBuddyBob1Dialog, 1, 9, 95, 200, question
                    [1])
                bobombQuizAnswer = 0
                o.oBobombBuddyCannonStatus = BOBOMB_BUDDY_CANNON_QUIZ_ASK
            end
        elseif o.oBobombBuddyCannonStatus == BOBOMB_BUDDY_CANNON_QUIZ_ASK then
            bobombQuizActive = true
            local buddyText = cutscene_object_with_dialog(CUTSCENE_DIALOG, o,
                gBehaviorValues.dialogs.BobombBuddyBob1Dialog)
            if buddyText ~= 0 then
                if bobombQuizAnswer + 1 == questionList[bobombQuizQuestion][2] then
                    cur_obj_play_sound_1(SOUND_GENERAL2_RIGHT_ANSWER)
                    smlua_text_utils_dialog_replace(gBehaviorValues.dialogs.BobombBuddyBob1Dialog, 1, 2, 95, 200,
                        DIALOG_QUIZ_CORRECT)
                    smlua_text_utils_dialog_replace(gBehaviorValues.dialogs.BobombBuddyOther1Dialog, 1, 2, 95, 200,
                        DIALOG_QUIZ_CORRECT)
                    if not _G.bossRushOn then
                        gotQuestionRight = true
                        o.oBobombBuddyCannonStatus = BOBOMB_BUDDY_CANNON_UNOPENED
                    else
                        o.oBobombBuddyCannonStatus = BOBOMB_BUDDY_CANNON_QUIZ_START
                    end
                else
                    cur_obj_play_sound_1(SOUND_MENU_CAMERA_BUZZ)
                    smlua_text_utils_dialog_replace(gBehaviorValues.dialogs.BobombBuddyBob1Dialog, 1, 3, 95, 200,
                        DIALOG_QUIZ_WRONG)
                    o.oBobombBuddyCannonStatus = BOBOMB_BUDDY_CANNON_QUIZ_WRONG
                end
            end
        elseif o.oBobombBuddyCannonStatus == BOBOMB_BUDDY_CANNON_QUIZ_WRONG then
            local buddyText = 1
            if not _G.bossRushOn then
                buddyText = cutscene_object_with_dialog(CUTSCENE_DIALOG, o, gBehaviorValues.dialogs.BobombBuddyBob1Dialog)
            end

            if buddyText ~= 0 then
                o.oBobombBuddyCannonStatus = BOBOMB_BUDDY_CANNON_STOP_TALKING
                if _G.bossRushOn then
                    o.oBobombBuddyCannonStatus = BOBOMB_BUDDY_CANNON_QUIZ_START
                end
                local m = gMarioStates[0]
                o.oInteractionSubtype = o.oInteractionSubtype & ~INT_SUBTYPE_DELAY_INVINCIBILITY
                o.oDamageOrCoinValue = 2
                take_damage_and_knock_back(m, o)
            end
        end
    end
end

hook_behavior(id_bhvBobombBuddyOpensCannon, OBJ_LIST_GENACTOR, false, custom_buddy_init, custom_buddy_loop,
    "bhvBobombBuddyOpensCannon")

local stickUpTimer = 0
local stickDownTimer = 0
local quizMusic = false
function render_quiz()
    if bobombQuizActive and get_dialog_box_state() ~= 0 then
        if not (quizMusic or _G.bossRushOn) then
            seq_player_unlower_volume(SEQ_PLAYER_LEVEL, 0)
            play_music(SEQ_PLAYER_LEVEL, SEQ_MENU_FILE_SELECT, 0)
            quizMusic = true
        end
    elseif quizMusic then
        stop_background_music(SEQ_MENU_FILE_SELECT)
        quizMusic = false
        return
    else
        return
    end

    if get_dialog_box_state() ~= 1 then return end

    djui_hud_set_resolution(RESOLUTION_N64)
    local screenWidth = djui_hud_get_screen_width()
    local x = screenWidth * 0.5 - 64
    local y = 16 * (7 + bobombQuizAnswer) + 6
    djui_hud_set_color(255, 255, 255, 255)
    djui_hud_render_texture(gTextures.star, x, y, 1, 1)
    if gMarioStates[0].controller.rawStickY > 64 then
        if stickUpTimer == 0 then
            stickUpTimer = 5
            bobombQuizAnswer = (bobombQuizAnswer + 3) % 4
            play_sound(SOUND_MENU_CHANGE_SELECT, gMarioStates[0].marioObj.header.gfx.cameraToObject)
        else
            stickUpTimer = stickUpTimer - 1
        end
    else
        stickUpTimer = 0
    end
    if gMarioStates[0].controller.rawStickY < -64 then
        if stickDownTimer == 0 then
            stickDownTimer = 5
            bobombQuizAnswer = (bobombQuizAnswer + 1) % 4
            play_sound(SOUND_MENU_CHANGE_SELECT, gMarioStates[0].marioObj.header.gfx.cameraToObject)
        else
            stickDownTimer = stickDownTimer - 1
        end
    else
        stickDownTimer = 0
    end
end

hook_event(HOOK_ON_HUD_RENDER, render_quiz)
